
#include <string>
#include <vector>
#include <string.h>
#include <iostream.h>
#include <time.h>
#include <winsock2.h>

#define maxinputstring 1024
#define telnet_port 23;
#define maxtime_waitclose 10

using namespace std;


enum t_tsaction {tserror,tsrun,tshelp};
union t_tsoption {
	int tsdiag:1;
	int tssilent:1;
};
char tsoptin_prefix[]= {"-/\\"};
enum t_tsoption_letter {tslet_help1='h', tslet_help2='?', tslet_diag='d', tslet_silent='s'};

enum t_tserrcode {tssuccess, tsinvalid_option,tsinvalid_parnum,tsunknow_command, 
	tsbad_pause_time,tsbad_sendline_format,tserr_send_char,
	tsbad_waitline_format,tserr_get_char, tserr_open_session
};
char tserrdescr[][31]={"","Bad parameter","Bad parameter number", "Unknown command",
	"Incorrect pause time","Incorrect transmit line format","Can't send data to host",
	"Incorrect wait line format","Can't receive data from host", "Can't connect to host"
	};

enum t_tsdiagcode {tsdiagnone,tsdiag_initwinsock,tsdiag_closewinsock,tsdiag_transparam,
	tsdiag_getnextline,tsdiag_processline,tsdiag_closesession,tsdiag_gethost,
	tsdiag_connecthost,tsdiag_pause, tsdiag_sendtext, tsdiag_waittext, tsdiag_execline,
	tsdiag_opensocket};
char tsdiagdescr[][34]={"","Initialize winsock api","Close winsock api","Translate command line papameters",
	"Read next script line", "Process script line","Close telnet session","Get host by name",
	"Connect to host ","Pause", "Send ", "Wait ", "Execute script line",
	"Open socket"};

enum t_tsruncommand {tsr_error, tsr_none, tsr_open, tsr_close, tsr_exit, tsr_quit, tsr_wait, tsr_send,
	tsr_pause};
char tsruncommands [][9]={"","rem","open","close","exit","quit","waitfor","transmit","pause"};
char tsruncommand_comment= {';'};

char tssubst_param='%';
char tsemptysymbols[]=" \t";

struct t_tssubst_record {
	char sinit[3];
	char send[2];
};

#define tssubst_table_size 26
t_tssubst_record tssubst_table[tssubst_table_size]={{"^A","\001"},{"^B","\002"},{"^C","\003"},
{"^D","\004"},{"^E","\005"},{"^F","\006"},{"^G","\007"},{"^H","\010"},{"^I","\011"},{"^J","\012"},
{"^K","\013"},{"^L","\014"},{"^M","\n"},{"^N","\016"},{"^O","\017"},{"^P","\020"},{"^Q","\021"},
{"^R","\022"},{"^S","\023"},{"^T","\024"},{"^U","\025"},{"^V","\026"},{"^W","\027"},{"^X","\030"},
{"^Y","\031"},{"^Z","\032"}};


char ts_copyright[]="Telnet Script Executor V.1.0.(c)2001 Lubimkov Dmitri (Loft@onego.ru)\n";
char ts_helpmsg[]="Usage telnet scripts execution program:\n\
tse.exe [options] [parameters] [<scriptfile] [>outputfile]\n\
[options]:\n\
-s: silent mode\n\
-d: show diagnostic messages\n\
-h: show help screen\n\
[parameters] is list of command line parameters that can be processed by script file.\
 For syntax of scripts see readme.txt file\n\
[scriptfile] is file name with script to run. If this name is ommited program will\
 wait commands from console.\n\
[outputfile] is file name for program output. If this name is ommited program will\
 output messages to screen.\n";


struct t_tserror {
	t_tserror (t_tserrcode errcode, const char* ei) {tserrcode=errcode;errinfo=ei;};
	t_tserrcode tserrcode;
	string errinfo;
};


typedef vector <string> t_arr_param;

class c_telnet {
public:
	c_telnet();
	~c_telnet();
	bool is_session_open(){return session_open;};
	void close_session();
	void closewait_session();
	bool open_session(string ipadr, unsigned int port);
	bool getwait_nextchar();
	bool put_nextchar(char ch);
	char chinout;
private:
	bool session_open;
	string ipaddr;
	unsigned int tcpport;
	SOCKET sct;
	SOCKADDR_IN sctadr;
};

class c_ts:public c_telnet {
public:
	c_ts(int argc, char* argv[]);
	~c_ts() { c_telnet::~c_telnet(); };
	void run ();
	
private:
	t_tsaction tsaction;
	t_tsoption tsoption;
	t_arr_param tsparam;
	t_tsruncommand tsruncommand;

	string oneline;
	string onelinetmp;
	int linenumber;

	bool quitflag;

	bool is_arg_param(char* arg);
	void getoneline();
	void processline();
	void executeline();
	void extract_runcommand();
	void error_in_script(t_tserrcode errcode);
	void dopause();
	void sendtext();
	void waittext();
	void preparetextline(t_tserrcode errcode);
	void connecttohost();
};